//	Copyright (c) 1993, University of Kansas, All Rights Reserved
//
//	Class:		TDosLynx : public TApplication
//	Include File:	TDosLynx.h
//	Purpose:	Implement our application object.
//	Remarks/Portability/Dependencies/Restrictions:
//	Revision History:
//		12-09-93	created
//		02-09-94	Split all members into seperate files to
//				enhance overlay support.
#include"tdoslynx.h"

void TDosLynx::idle()	{
//	Purpose:	Accomplish idle time processing when no input
//	Arguments:	void
//	Return Value:   void
//	Remarks/Portability/Dependencies/Restrictions:
//	Revision History:
//		12-13-93	created
//		08-09-94	Modified not to depend on presence of views.

	//	Call base object idle
	TProgram::idle();

	//	Update our evolving views
	if(TSV_sock != NULL)	{
		TSV_sock->update();
	}
	if(TCV_clock != NULL)	{
		TCV_clock->update();
	}
	if(THV_heap != NULL)	{
		THV_heap->update();
	}
	if(TDV_disk != NULL)	{
		TDV_disk->update();
	}
}
