#*****************************************************************
#* MODULE INFORMATION*
#*********************
#*      FILE    NAME:           PWT.MAK
#*      SYSTEM  NAME:           POWER
#*      VERSION NUMBER:         3.00
#*
#* DESCRIPTION: MSDOS Turbo C Makefile
#*              Programmer Oriented Window Environment Routines.
#*              (NoC) July 1989 - Ling Thio Software Productions.
#*****************************************************************
#* ADMINISTRATIVE INFORMATION*
#*****************************
#*      ORIGINAL AUTHOR:    Ling Thio
#*      CREATION DATE:      89/07/10
#*      CHANGES:            none
#*****************************************************************

###
#   The globals
###

MODE  = T
# R : Real Mode
# P : Protected Mode

SYS = $(MODEL)POWER3$(MODE)
CS = .

# Optimize: O,G,Z
# Warning:  w-All, wpia-Possibli incorrec assignment off
DCOPT = -O -G -Z -w -w-pia -m$(MODL) -DMOUSE
#DAOPT = /w2 /mx /d$(MEM_MODEL)
DAOPT = /W2 /Mx /D$(MEM_MODEL)

###
#   The dependenties
###
OL = \
$(MODE)$(MODEL)BINIT.OBJ \
$(MODE)$(MODEL)GBLOC.OBJ \
$(MODE)$(MODEL)GCOPY.OBJ \
$(MODE)$(MODEL)GHSCR.OBJ \
$(MODE)$(MODEL)GINIT.OBJ \
$(MODE)$(MODEL)GFILE.OBJ \
$(MODE)$(MODEL)GGETK.OBJ \
$(MODE)$(MODEL)GHBAR.OBJ \
$(MODE)$(MODEL)GHEXD.OBJ \
$(MODE)$(MODEL)GINP.OBJ  \
$(MODE)$(MODEL)GKEY.OBJ  \
$(MODE)$(MODEL)GMENU.OBJ \
$(MODE)$(MODEL)GOPEN.OBJ \
$(MODE)$(MODEL)GPUT.OBJ  \
$(MODE)$(MODEL)GVBAR.OBJ \
$(MODE)$(MODEL)GVSCR.OBJ \
$(MODE)$(MODEL)GWAIT.OBJ \
$(MODE)$(MODEL)GHEAD.OBJ \
$(MODE)$(MODEL)MUTI.OBJ  \
$(MODE)$(MODEL)MVIO.OBJ  \
$(MODE)$(MODEL)VASM.OBJ  \
$(MODE)$(MODEL)VINIT.OBJ

$(MODE)$(MODEL)DEMO.EXE : $(SYS).LIB $(MODE)$(MODEL)DEMO.OBJ
    tcc $(DCOPT) -e$(MODE)$(MODEL)DEMO.EXE $(MODE)$(MODEL)DEMO.OBJ $(SYS).LIB

$(SYS).LIB : $(OL)
#    LIB @PW$(MODE)$(MODEL).LNK
    TLIB $(SYS) \
-+$(MODE)$(MODEL)BINIT.OBJ \
-+$(MODE)$(MODEL)GBLOC.OBJ \
-+$(MODE)$(MODEL)GCOPY.OBJ \
-+$(MODE)$(MODEL)GFILE.OBJ \
-+$(MODE)$(MODEL)GGETK.OBJ \
-+$(MODE)$(MODEL)GHSCR.OBJ \
-+$(MODE)$(MODEL)GHBAR.OBJ \
-+$(MODE)$(MODEL)GHEXD.OBJ
    TLIB $(SYS) \
-+$(MODE)$(MODEL)GINIT.OBJ \
-+$(MODE)$(MODEL)GINP.OBJ  \
-+$(MODE)$(MODEL)GKEY.OBJ  \
-+$(MODE)$(MODEL)GMENU.OBJ \
-+$(MODE)$(MODEL)GOPEN.OBJ \
-+$(MODE)$(MODEL)GPUT.OBJ
    TLIB $(SYS) \
-+$(MODE)$(MODEL)GVBAR.OBJ \
-+$(MODE)$(MODEL)GVSCR.OBJ \
-+$(MODE)$(MODEL)GWAIT.OBJ \
-+$(MODE)$(MODEL)GHEAD.OBJ \
-+$(MODE)$(MODEL)MUTI.OBJ  \
-+$(MODE)$(MODEL)MVIO.OBJ  \
-+$(MODE)$(MODEL)VASM.OBJ  \
-+$(MODE)$(MODEL)VINIT.OBJ

$(MODE)$(MODEL)BINIT.OBJ : PWBINIT.C
    tcc -c $(DCOPT) -o$(MODE)$(MODEL)BINIT.OBJ PWBINIT.C

$(MODE)$(MODEL)GBLOC.OBJ : PWGBLOC.C
    tcc -c $(DCOPT) -o$(MODE)$(MODEL)GBLOC.OBJ PWGBLOC.C

$(MODE)$(MODEL)GCOPY.OBJ : PWGCOPY.C
    tcc -c $(DCOPT) -o$(MODE)$(MODEL)GCOPY.OBJ PWGCOPY.C

$(MODE)$(MODEL)GFILE.OBJ : PWGFILE.C
    tcc -c $(DCOPT) -o$(MODE)$(MODEL)GFILE.OBJ PWGFILE.C

$(MODE)$(MODEL)GGETK.OBJ : PWGGETK.C
    tcc -c $(DCOPT) -o$(MODE)$(MODEL)GGETK.OBJ PWGGETK.C

$(MODE)$(MODEL)GHBAR.OBJ : PWGHBAR.C
    tcc -c $(DCOPT) -o$(MODE)$(MODEL)GHBAR.OBJ PWGHBAR.C

$(MODE)$(MODEL)GHEXD.OBJ : PWGHEXD.C
    tcc -c $(DCOPT) -o$(MODE)$(MODEL)GHEXD.OBJ PWGHEXD.C

$(MODE)$(MODEL)GHSCR.OBJ : PWGHSCR.C
    tcc -c $(DCOPT) -o$(MODE)$(MODEL)GHSCR.OBJ PWGHSCR.C

$(MODE)$(MODEL)GINIT.OBJ : PWGINIT.C
    tcc -c $(DCOPT) -o$(MODE)$(MODEL)GINIT.OBJ PWGINIT.C

$(MODE)$(MODEL)GINP.OBJ : PWGINP.C
    tcc -c $(DCOPT) -o$(MODE)$(MODEL)GINP.OBJ PWGINP.C

$(MODE)$(MODEL)GKEY.OBJ : PWGKEY.C
    tcc -c $(DCOPT) -o$(MODE)$(MODEL)GKEY.OBJ PWGKEY.C

$(MODE)$(MODEL)GMENU.OBJ : PWGMENU.C
    tcc -c $(DCOPT) -o$(MODE)$(MODEL)GMENU.OBJ PWGMENU.C

$(MODE)$(MODEL)GOPEN.OBJ : PWGOPEN.C
    tcc -c $(DCOPT) -o$(MODE)$(MODEL)GOPEN.OBJ PWGOPEN.C

$(MODE)$(MODEL)GPUT.OBJ : PWGPUT.C
    tcc -c $(DCOPT) -o$(MODE)$(MODEL)GPUT.OBJ PWGPUT.C

$(MODE)$(MODEL)GVBAR.OBJ : PWGVBAR.C
    tcc -c $(DCOPT) -o$(MODE)$(MODEL)GVBAR.OBJ PWGVBAR.C

$(MODE)$(MODEL)GVSCR.OBJ : PWGVSCR.C
    tcc -c $(DCOPT) -o$(MODE)$(MODEL)GVSCR.OBJ PWGVSCR.C

$(MODE)$(MODEL)GWAIT.OBJ : PWGWAIT.C
    tcc -c $(DCOPT) -o$(MODE)$(MODEL)GWAIT.OBJ PWGWAIT.C

$(MODE)$(MODEL)GHEAD.OBJ : PWGHEAD.C
    tcc -c $(DCOPT) -o$(MODE)$(MODEL)GHEAD.OBJ PWGHEAD.C

$(MODE)$(MODEL)MVIO.OBJ :PWMVIO.ASM
    masm $(DAOPT) PWMVIO.ASM,$(MODE)$(MODEL)MVIO.OBJ;

$(MODE)$(MODEL)MUTI.OBJ : PWMUTI.C
    tcc -c $(DCOPT) -o$(MODE)$(MODEL)MUTI.OBJ PWMUTI.C

$(MODE)$(MODEL)VASM.OBJ :PWVASM.ASM
    masm $(DAOPT) PWVASM.ASM,$(MODE)$(MODEL)VASM.OBJ;

$(MODE)$(MODEL)VINIT.OBJ : PWVINIT.C
    tcc -c $(DCOPT) -o$(MODE)$(MODEL)VINIT.OBJ PWVINIT.C

$(MODE)$(MODEL)DEMO.OBJ : PWDEMO.C
    tcc -c $(DCOPT) -o$(MODE)$(MODEL)DEMO.OBJ PWDEMO.C
