/* hfile.inc - placed into all .h files to set up for PVCS 
   $Header:   E:/pcdirs/vcs/vskeys.h_v   1.0   15 Jan 1990 19:30:30   bkc  $
   Revision History ----------------------------------------------------
   $Log:   E:/pcdirs/vcs/vskeys.h_v  $
 * 
 *    Rev 1.0   15 Jan 1990 19:30:30   bkc
*/


/*
 *		@(#)vskeys.h	1.25	(NCSA)	4/29/88
 *
 *      Virtual Screen Kernel Keys and Attribute Definitions
 *              (vskeys.c)
 *  
 *      by Gaige B. Paulsen
 *
 *      This file contains equates used by the program for specification of
 *  special Keyboard characters and definition of the Attribute byte.
 *
 *      Version Date    Notes
 *      ------- ------  ---------------------------------------------------
 *      0.01    861102  Initial coding -GP
 *
 */

#define VSUP    129     /* Up Arrow */
#define VSDN    130     /* Down Arrow */
#define VSRT    131     /* Right Arrow */
#define VSLT    132     /* Left Arrow */

#define VSK0    133     /* Keypad 0 */
#define VSK1    134     /* Keypad 1 */
#define VSK2    135     /* Keypad 2 */
#define VSK3    136     /* Keypad 3 */
#define VSK4    137     /* Keypad 4 */
#define VSK5    138     /* Keypad 5 */
#define VSK6    139     /* Keypad 6 */
#define VSK7    140     /* Keypad 7 */
#define VSK8    141     /* Keypad 8 */
#define VSK9    142     /* Keypad 9 */

#define VSKC    143     /* Keypad , */
#define VSKM    144     /* Keypad - */
#define VSKP    145     /* Keypad . */
#define VSKE    146     /* Keypad Enter */

#define VSF1    147     /* Function 1 */
#define VSF2    148     /* Function 2 */
#define VSF3    149     /* Function 3 */
#define VSF4    150     /* Function 4 */

#ifdef VSMASTER
char VSIkpxlate[2][29] =
	{	"ABCD0123456789,-.\15PQRS",
		"ABCDpqrstuvwxylmnMPQRSTUVWXY"
	};
#else
extern char *VSIkpxlate;
#endif

/*
 *          Definition of attribute bits in the Virtual Screen
 *
 *          0   -   Bold
 *          1   -   
 *          2   -
 *          3   -   Underline
 *          4   -   Blink
 *          5   -
 *          6   -   Reverse
 *          7   -   Graphics character set
 *
 */

#define VSisbold(x) (x & 0x01)
#define VSisundl(x) (x & 0x08)
#define VSisblnk(x) (x & 0x10)
#define VSisrev(x)  (x & 0x40)
#define VSisgrph(x) (x & 0x100)
#define VSinattr(x) (x & 0xd9)

#define VSgraph(x)  (x | 0x100)
#define VSnotgraph(x) (x & 0xff)
